Index: NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/nemogcm.F90
===================================================================
--- NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/nemogcm.F90	(revision 13159)
+++ NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/nemogcm.F90	(revision 13197)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                       ***  MODULE nemogcm   ***
-   !! StandAlone Surface module : surface fluxes
+   !!                      STATION_ASF (SAS meets C1D)
    !!======================================================================
    !! History :  3.6  ! 2011-11  (S. Alderson, G. Madec) original code
@@ -19,17 +19,16 @@
    !!----------------------------------------------------------------------
    USE step_oce       ! module used in the ocean time stepping module (step.F90)
-   USE sbc_oce        ! surface boundary condition: ocean #LB: rm?
    USE phycst         ! physical constant                  (par_cst routine)
    USE domain         ! domain initialization   (dom_init & dom_cfg routines)
    USE closea         ! treatment of closed seas (for ln_closea)
    USE usrdef_nam     ! user defined configuration
+   USE istate         ! initial state setting          (istate_init routine)
    USE step, ONLY : Nbb, Nnn, Naa, Nrhs ! time level indices
    USE daymod         ! calendar
    USE restart        ! open  restart file
-   !LB:USE step           ! NEMO time-stepping                 (stp     routine)
    USE c1d            ! 1D configuration
    USE step_c1d       ! Time stepping loop for the 1D configuration
-   USE sbcssm         !
    !
+   USE in_out_manager ! I/O manager
    USE lib_mpp        ! distributed memory computing
    USE mppini         ! shared/distributed memory setting (mpp_init routine)
@@ -49,5 +48,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: nemogcm.F90 11536 2019-09-11 13:54:18Z smasson $
+   !! $Id: nemogcm.F90 12489 2020-02-28 15:55:11Z davestorkey $
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
@@ -84,4 +83,7 @@
       !                            !==   time stepping   ==!
       !                            !-----------------------!
+      !
+      !                                               !== set the model time-step  ==!
+      !
       istp = nit000
       !
@@ -107,8 +109,7 @@
       !
 #if defined key_iomput
-      CALL xios_finalize  ! end mpp communications with xios
+                                    CALL xios_finalize  ! end mpp communications with xios
 #else
-      IF( lk_mpp   ) THEN   ;   CALL mppstop      ! end mpp communications
-      ENDIF
+      IF( lk_mpp )                  CALL mppstop      ! end mpp communications
 #endif
       !
@@ -162,9 +163,15 @@
       IF( lwm )   CALL ctl_opn(     numout,        'ocean.output', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, -1, .FALSE. )
       ! open reference and configuration namelist files
-      CALL load_nml( numnam_ref,        'namelist_ref',                                           -1, lwm )
-      CALL load_nml( numnam_cfg,        'namelist_cfg',                                           -1, lwm )
+                  CALL load_nml( numnam_ref,        'namelist_ref',                                           -1, lwm )
+                  CALL load_nml( numnam_cfg,        'namelist_cfg',                                           -1, lwm )
       IF( lwm )   CALL ctl_opn(     numond, 'output.namelist.dyn', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, -1, .FALSE. )
       ! open /dev/null file to be able to supress output write easily
-      CALL ctl_opn(     numnul,           '/dev/null', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, -1, .FALSE. )
+      IF( Agrif_Root() ) THEN
+                  CALL ctl_opn(     numnul,           '/dev/null', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, -1, .FALSE. )
+#ifdef key_agrif
+      ELSE
+                  numnul = Agrif_Parent(numnul)   
+#endif
+      ENDIF
       !
       !                             !--------------------!
@@ -222,5 +229,5 @@
 903   IF( ios /= 0 )   CALL ctl_nam ( ios , 'namcfg in reference namelist' )
       READ  ( numnam_cfg, namcfg, IOSTAT = ios, ERR = 904 )
-904   IF( ios >  0 )   CALL ctl_nam ( ios , 'namcfg in configuration namelist' )
+904   IF( ios >  0 )   CALL ctl_nam ( ios , 'namcfg in configuration namelist' )   
       !
       IF( ln_read_cfg ) THEN            ! Read sizes in domain configuration file
@@ -253,26 +260,16 @@
       IF( ln_timing    )   CALL timing_start( 'nemo_init')
       !
-      CALL     phy_cst         ! Physical constants
-      CALL     eos_init        ! Equation of state
+                           CALL     phy_cst         ! Physical constants
+                           CALL     eos_init        ! Equation of state
       IF( lk_c1d       )   CALL     c1d_init        ! 1D column configuration
-      CALL     dom_init( Nbb, Nnn, Naa, "OPA") ! Domain
+                           CALL     dom_init( Nbb, Nnn, Naa, "OPA") ! Domain
       IF( sn_cfctl%l_prtctl )   &
          &                 CALL prt_ctl_init        ! Print control
-
-      IF( ln_rstart ) THEN                    ! Restart from a file                                                                                 
-         !                                    ! -------------------                                                                                 
-         CALL rst_read( Nbb, Nnn )            ! Read the restart file                                                                               
-         CALL day_init                        ! model calendar (using both namelist and restart infos)                                              
-         !                                                                                                                                          
-      ELSE                                    ! Start from rest                                                                                     
-         !                                    ! ---------------                                                                                     
-         numror = 0                           ! define numror = 0 -> no restart file to read                                                        
-         neuler = 0                           ! Set time-step indicator at nit000 (euler forward)                                                   
-         CALL day_init                        ! model calendar (using both namelist and restart infos)                                              
-      ENDIF
-      !
-
-      !                                      ! external forcing
-      CALL     sbc_init( Nbb, Nnn, Naa )    ! surface boundary conditions (including sea-ice)
+      !
+      
+                           CALL  istate_init( Nbb, Nnn, Naa )    ! ocean initial state (Dynamics and tracers)
+
+      !                                      ! external forcing 
+                           CALL     sbc_init( Nbb, Nnn, Naa )    ! surface boundary conditions (including sea-ice)
 
       !
@@ -305,8 +302,8 @@
          WRITE(numout,*) '                              sn_cfctl%l_prttrc  = ', sn_cfctl%l_prttrc
          WRITE(numout,*) '                              sn_cfctl%l_oasout  = ', sn_cfctl%l_oasout
-         WRITE(numout,*) '                              sn_cfctl%procmin   = ', sn_cfctl%procmin
-         WRITE(numout,*) '                              sn_cfctl%procmax   = ', sn_cfctl%procmax
-         WRITE(numout,*) '                              sn_cfctl%procincr  = ', sn_cfctl%procincr
-         WRITE(numout,*) '                              sn_cfctl%ptimincr  = ', sn_cfctl%ptimincr
+         WRITE(numout,*) '                              sn_cfctl%procmin   = ', sn_cfctl%procmin  
+         WRITE(numout,*) '                              sn_cfctl%procmax   = ', sn_cfctl%procmax  
+         WRITE(numout,*) '                              sn_cfctl%procincr  = ', sn_cfctl%procincr 
+         WRITE(numout,*) '                              sn_cfctl%ptimincr  = ', sn_cfctl%ptimincr 
          WRITE(numout,*) '      level of print                  nn_print   = ', nn_print
          WRITE(numout,*) '      Start i indice for SUM control  nn_ictls   = ', nn_ictls
@@ -423,5 +420,5 @@
       !!----------------------------------------------------------------------
       !
-      ierr =        oce_alloc    ()    ! ocean
+      ierr =        oce_alloc    ()    ! ocean 
       ierr = ierr + dia_wri_alloc()
       ierr = ierr + dom_oce_alloc()    ! ocean domain
@@ -432,5 +429,5 @@
    END SUBROUTINE nemo_alloc
 
-
+   
    SUBROUTINE nemo_set_cfctl(sn_cfctl, setto )
       !!----------------------------------------------------------------------
@@ -456,2 +453,3 @@
    !!======================================================================
 END MODULE nemogcm
+
Index: NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/sbcssm.F90
===================================================================
--- NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/sbcssm.F90	(revision 13159)
+++ NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/sbcssm.F90	(revision 13197)
@@ -54,5 +54,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/SAS 4.0 , NEMO Consortium (2018)
-   !! $Id: sbcssm.F90 10068 2018-08-28 14:09:04Z nicolasmartin $
+   !! $Id: sbcssm.F90 12615 2020-03-26 15:18:49Z laurent $
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/step_c1d.F90
===================================================================
--- NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/step_c1d.F90	(revision 13159)
+++ NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/step_c1d.F90	(revision 13197)
@@ -26,5 +26,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: step_c1d.F90 10068 2018-08-28 14:09:04Z nicolasmartin $
+   !! $Id: step_c1d.F90 12377 2020-02-12 14:39:06Z acc $
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
@@ -64,4 +64,7 @@
       CALL sbc    ( kstp, Nbb, Nnn )  ! Sea Boundary Condition (including sea-ice)
 
+      !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+      ! diagnostics and outputs
+      !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       CALL dia_wri( kstp, Nnn )  ! ocean model: outputs
 
Index: NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/usrdef_hgr.F90
===================================================================
--- NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/usrdef_hgr.F90	(revision 13159)
+++ NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/usrdef_hgr.F90	(revision 13197)
@@ -14,5 +14,5 @@
    !!   usr_def_hgr   : initialize the horizontal mesh 
    !!----------------------------------------------------------------------
-   USE dom_oce  , ONLY: nimpp, njmpp        ! ocean space and time domain
+   USE dom_oce  , ONLY: nimpp, njmpp       ! ocean space and time domain
    USE c1d      ,  ONLY: rn_lon1d, rn_lat1d ! ocean lon/lat define by namelist
    USE par_oce        ! ocean space and time domain
@@ -30,5 +30,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: usrdef_hgr.F90 10072 2018-08-28 15:21:50Z nicolasmartin $
+   !! $Id: usrdef_hgr.F90 12489 2020-02-28 15:55:11Z davestorkey $ 
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
@@ -54,5 +54,5 @@
       !!
       !! ** Action  : - define longitude & latitude of t-, u-, v- and f-points (in degrees) 
-      !!              - define coriolis parameter at f-point if the domain in not on the sphere
+      !!              - define coriolis parameter at f-point if the domain in not on the sphere (on beta-plane)
       !!              - define i- & j-scale factors at t-, u-, v- and f-points (in meters)
       !!              - define u- & v-surfaces (if gridsize reduction is used in some straits) (in m2)
Index: NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/usrdef_nam.F90
===================================================================
--- NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/usrdef_nam.F90	(revision 13159)
+++ NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/usrdef_nam.F90	(revision 13197)
@@ -8,5 +8,5 @@
    !!======================================================================
    !! History :  4.0  ! 2016-03  (S. Flavoni, G. Madec)  Original code
-   !! History :  4.x  ! 2019-10  (L. Brodeau) for STATION_ASF (C1D meets SAS)
+   !!            4.x  ! 2019-10  (L. Brodeau) for STATION_ASF (C1D meets SAS)
    !!----------------------------------------------------------------------
 
@@ -15,6 +15,6 @@
    !!   usr_def_hgr   : initialize the horizontal mesh 
    !!----------------------------------------------------------------------
-   USE dom_oce  , ONLY: nimpp, njmpp             ! ocean space and time domain
-   USE dom_oce  , ONLY: ln_zco, ln_zps, ln_sco   ! flag of type of coordinate
+   USE dom_oce  , ONLY: nimpp, njmpp       ! ocean space and time domain
+!!!   USE dom_oce  , ONLY: ln_zco, ln_zps, ln_sco   ! flag of type of coordinate
    USE par_oce        ! ocean space and time domain
    USE phycst         ! physical constants
@@ -33,5 +33,5 @@
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: usrdef_nam.F90 11536 2019-09-11 13:54:18Z smasson $ 
+   !! $Id: usrdef_nam.F90 12377 2020-02-12 14:39:06Z acc $ 
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
@@ -68,8 +68,8 @@
       kk_cfg = 0
 
-      ! Global Domain size: STATION_ASF domain is 3 x 3 grid-points x 75 or vertical levels
+      ! Global Domain size: STATION_ASF domain is 3 x 3 grid-points x 2 or vertical levels
       kpi = 3
       kpj = 3
-      kpk = 1
+      kpk = 2    ! 2, rather than 1, because 1 would cause some issues... like overflow in array boundary indexes, etc...
       !
       !                             ! Set the lateral boundary condition of the global domain
Index: NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/usrdef_zgr.F90
===================================================================
--- NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/usrdef_zgr.F90	(revision 13159)
+++ NEMO/branches/2020/dev_r12563_ASINTER-06_ABL_improvement/tests/STATION_ASF/MY_SRC/usrdef_zgr.F90	(revision 13197)
@@ -1,19 +1,21 @@
 MODULE usrdef_zgr
    !!======================================================================
-   !!                     ***  MODULE usrdef_zgr  ***
+   !!                       ***  MODULE  usrdef_zgr  ***
    !!
    !!                       ===  STATION_ASF case  ===
    !!
-   !! user defined :  vertical coordinate system of a user configuration
+   !! User defined : vertical coordinate system of a user configuration
    !!======================================================================
-   !! History :  4.0  ! 2019-10  (L. Brodeau)  Original code
+   !! History :  4.0  ! 2016-06  (G. Madec)  Original code
+   !!            4.x  ! 2019-10  (L. Brodeau) Station ASF
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
-   !!   usr_def_zgr   : user defined vertical coordinate system (required)
+   !!   usr_def_zgr   : user defined vertical coordinate system
+   !!      zgr_z      : reference 1D z-coordinate 
+   !!      zgr_top_bot: ocean top and bottom level indices
+   !!      zgr_zco    : 3D verticl coordinate in pure z-coordinate case
    !!---------------------------------------------------------------------
    USE oce            ! ocean variables
-   !USE dom_oce        ! ocean domain
-   !USE depth_e3       ! depth <=> e3
    USE usrdef_nam     ! User defined : namelist variables
    !
@@ -21,14 +23,13 @@
    USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
    USE lib_mpp        ! distributed memory computing library
-   USE timing         ! Timing
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   usr_def_zgr   ! called by domzgr.F90
+   PUBLIC   usr_def_zgr        ! called by domzgr.F90
 
    !!----------------------------------------------------------------------
    !! NEMO/OCE 4.0 , NEMO Consortium (2018)
-   !! $Id: usrdef_zgr.F90 10072 2018-08-28 15:21:50Z nicolasmartin $
+   !! $Id: usrdef_zgr.F90 12377 2020-02-12 14:39:06Z acc $
    !! Software governed by the CeCILL license (see ./LICENSE)
    !!----------------------------------------------------------------------
@@ -47,12 +48,12 @@
       !!
       !!----------------------------------------------------------------------
-      LOGICAL                   , INTENT(  out) ::   ld_zco, ld_zps, ld_sco      ! vertical coordinate flags ( read in namusr_def )
-      LOGICAL                   , INTENT(  out) ::   ld_isfcav                   ! under iceshelf cavity flag
-      REAL(wp), DIMENSION(:)    , INTENT(  out) ::   pdept_1d, pdepw_1d          ! 1D grid-point depth     [m]
-      REAL(wp), DIMENSION(:)    , INTENT(  out) ::   pe3t_1d , pe3w_1d           ! 1D grid-point depth     [m]
-      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   pdept, pdepw                ! grid-point depth        [m]
-      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   pe3t , pe3u , pe3v , pe3f   ! vertical scale factors  [m]
-      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   pe3w , pe3uw, pe3vw         ! i-scale factors
-      INTEGER , DIMENSION(:,:)  , INTENT(  out) ::   k_top, k_bot                ! first & last ocean level
+      LOGICAL                   , INTENT(out) ::   ld_zco, ld_zps, ld_sco      ! vertical coordinate flags
+      LOGICAL                   , INTENT(out) ::   ld_isfcav                   ! under iceshelf cavity flag
+      REAL(wp), DIMENSION(:)    , INTENT(out) ::   pdept_1d, pdepw_1d          ! 1D grid-point depth     [m]
+      REAL(wp), DIMENSION(:)    , INTENT(out) ::   pe3t_1d , pe3w_1d           ! 1D grid-point depth     [m]
+      REAL(wp), DIMENSION(:,:,:), INTENT(out) ::   pdept, pdepw                ! grid-point depth        [m]
+      REAL(wp), DIMENSION(:,:,:), INTENT(out) ::   pe3t , pe3u , pe3v , pe3f   ! vertical scale factors  [m]
+      REAL(wp), DIMENSION(:,:,:), INTENT(out) ::   pe3w , pe3uw, pe3vw         ! i-scale factors 
+      INTEGER , DIMENSION(:,:)  , INTENT(out) ::   k_top, k_bot                ! first & last ocean level
       !!----------------------------------------------------------------------
       !
@@ -61,10 +62,13 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
       !
-
+      !
+      ! type of vertical coordinate
+      ! ---------------------------
       ld_zco    = .TRUE.         ! z-coordinate without ocean cavities
       ld_zps    = .FALSE.
       ld_sco    = .FALSE.
       ld_isfcav = .FALSE.
-      
+
+      !! 1st level (the only one that matters)
       pdept_1d(1) = rn_dept1 ! depth (m) at which the SST is taken/measured == depth of first T point!
       pdepw_1d(1) = 0._wp
@@ -72,16 +76,33 @@
       pe3w_1d(1)  = rn_dept1 ! LB???
 
-      pdept(:,:,:) = rn_dept1
-      pdepw(:,:,:) = 0._wp
-      pe3t(:,:,:) = 2._wp*rn_dept1
-      pe3u(:,:,:) = 2._wp*rn_dept1
-      pe3v(:,:,:) = 2._wp*rn_dept1
-      pe3f(:,:,:) = 2._wp*rn_dept1
-      pe3w(:,:,:)  = rn_dept1  ! LB???
-      pe3uw(:,:,:) = rn_dept1  ! LB???
-      pe3vw(:,:,:) = rn_dept1  ! LB???
+      pdept(:,:,1) = rn_dept1
+      pdepw(:,:,1) = 0._wp
+      pe3t(:,:,1) = 2._wp*rn_dept1
+      pe3u(:,:,1) = 2._wp*rn_dept1
+      pe3v(:,:,1) = 2._wp*rn_dept1
+      pe3f(:,:,1) = 2._wp*rn_dept1
+      pe3w(:,:,1)  = rn_dept1  ! LB???
+      pe3uw(:,:,1) = rn_dept1  ! LB???
+      pe3vw(:,:,1) = rn_dept1  ! LB???
+      
+      !! 2nd level, technically useless (only for the sake of code stability)
+      pdept_1d(2) = 3._wp*rn_dept1
+      pdepw_1d(2) = 2._wp*rn_dept1
+      pe3t_1d(2)  = 2._wp*rn_dept1
+      pe3w_1d(2)  = 2._wp*rn_dept1
+
+      pdept(:,:,2) = 3._wp*rn_dept1
+      pdepw(:,:,2) = 2._wp*rn_dept1
+      pe3t(:,:,2) = 2._wp*rn_dept1
+      pe3u(:,:,2) = 2._wp*rn_dept1
+      pe3v(:,:,2) = 2._wp*rn_dept1
+      pe3f(:,:,2) = 2._wp*rn_dept1
+      pe3w(:,:,2)  = 2._wp*rn_dept1
+      pe3uw(:,:,2) = 2._wp*rn_dept1
+      pe3vw(:,:,2) = 2._wp*rn_dept1
+
       k_top = 1
       k_bot = 1
-      !
+
    END SUBROUTINE usr_def_zgr
    !!======================================================================
